/*-
 * Copyright (C) @BABOLO  2004 Nov 18
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2004 Nov 18\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cmd_get.c,v 1.9 2007/11/10 04:40:57 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <dirent.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <getCGIparm.h>
#include <mife.h>
#include <err.h>
#include <libpq-fe.h>
#include <babolo/BLINflag.h>
#include "pgoblin.h"
#include "pgob.h"

int
pgoblin_getarg(pgoblin_con *options, int a[]) {
    int ex = EX_OK;

    ifBLIN_QV3(options->flags) fprintf(stderr, "+pgoblin_getarg %d\n", a[PGO_POUT]);
    if  ((ex = getCGIparmarray( 0, (u_char **)options->argv, "any", "\t", "\\N"
                              , IO_OUT.wri
                              , IO_OUT.onu
        ))                    ) {
        ifBLIN_QV1(options->flags) warn("getCGIparmarray");
    }
    ifBLIN_QV3(options->flags) fprintf(stderr, "-pgoblin_getarg %d\n", ex);
    exit(ex);
}

int
pgoblin_getenv(pgoblin_con *options, int a[]) {
    int ex = EX_OK;

    ifBLIN_QV3(options->flags) fprintf(stderr, "+pgoblin_getenv %d\n", a[PGO_POUT]);
    if  ((ex = getCGIparmenv( gCGI_RNUM, (const u_char **)options->envp, "any", "\t", "\\N"
                            , IO_OUT.wri
                            , IO_OUT.onu
        ))                  ) {
        ifBLIN_QV1(options->flags) warn("getCGIparmenv");
    }
    ifBLIN_QV3(options->flags) fprintf(stderr, "-pgoblin_getenv %d\n", ex);
    exit(ex);
}

int
pgoblin_getget(pgoblin_con *options, int a[]) {
    int ex = EX_OK;

    ifBLIN_QV3(options->flags) fprintf(stderr, "+pgoblin_getget %d\n", a[PGO_POUT]);
    if  ((ex = getCGIparmcopy( gCGI_RNUM|gCGI_SEPR, getenv("QUERY_STRING"), "any", "\t", "\\N"
                             , IO_OUT.wri
                             , IO_OUT.onu
        ))                   ) {
        ifBLIN_QV1(options->flags) warn("getget getCGIparmcopy");
    }
    ifBLIN_QV3(options->flags) fprintf(stderr, "-pgoblin_getget %d\n", ex);
    exit(ex);
}

int
pgoblin_getpost(pgoblin_con *options, int a[]) {
    int ex = EX_OK;
    mife_descriptor *in;

    in = IO_IN.mife;
    ifBLIN_QV3(options->flags)
        fprintf(stderr, "+pgoblin_getpost %d in %s\n", a[PGO_POUT], in ? "OK" : "NULL");
    if  (mife_read(in, 0, 0) < 0) {
        ifBLIN_QV1(options->flags) warn("getpost 1");
        return(EX_OSERR);
    }
    if  ((ex = getCGIparmcopy( gCGI_RNUM|gCGI_SEPR, mife_get(in, 0), "any", "\t", "\\N"
                             , IO_OUT.wri
                             , IO_OUT.onu
        ))                   ) {
        ifBLIN_QV1(options->flags) warn("getpost getCGIparmcopy");
    }
    ifBLIN_QV3(options->flags) fprintf(stderr, "-pgoblin_getpost %d\n", ex);
    exit(ex);
}

int
pgoblin_getproc(pgoblin_con *options, int a[]) {
    int ex = EX_OK;

    ifBLIN_QV3(options->flags) fprintf(stderr, "+pgoblin_getproc %d\n", a[PGO_POUT]);
    if  ((ex = getCGIparmproc( 0, "any", "\t", "\\N"
                             , IO_OUT.wri
                             , IO_OUT.onu
        ))                   ) {
        ifBLIN_QV1(options->flags) warn("getCGIparmproc");
    }
    ifBLIN_QV3(options->flags) fprintf(stderr, "-pgoblin_getproc %d\n", ex);
    exit(ex);
}
